
#include "bits/bitcombminchange.h"

#include "fxttypes.h"
#include "bits/printbin.h"
#include "jjassert.h"
#include "demo/nextarg.h"

#include "fxtio.h"

//% Generating combinations of bits (as binary words) in minimal-change order.


int
main(int argc, char **argv)
{
    ulong n = 7, k = 4;
    NXARG(n, "Minchange combinations (n over k):  n  (n>0)");
    NXARG(k, "  (0<k<=n)");

    jjassert( n>0 );
    jjassert( k>0 );
    jjassert( n>=k );

    const ulong pd = n;
    ulong last = igc_last_comb(k, n);
    ulong c, nc = first_sequency(k);
    ulong g, gg = 0;
    do
    {
        c = nc;
        nc = igc_next_minchange_comb(c);

        print_bin_nn("    ", c, pd);
        print_bin_nn("    ", nc-c, pd);

        g = gray_code(c);
        print_bin_nn("    ", g, pd);
        if ( gg )  print_bin_diff_nn("    ", gg, g, pd, ".1+-");
        gg = g;

        cout << endl;
    }
    while ( c!=last );

    cout << endl;

    return 0;
}
// -------------------------
